<?php

//------------------------------------------------------------------------------
// Twitoaster post replies (Twitter Comments)
//------------------------------------------------------------------------------

	function twitoaster_post_replies_twitter_comments()
	{
		global $twitoaster_options, $twitoaster_meta, $post;

		// Needs Post Replies lookup (or refresh)
		if ($twitoaster_meta['expire'] < time())
		{
			// Twitoaster API Request
			$twitoaster_api_result = twitoaster_api_request('GET', 'conversation/search', array('query' => get_permalink(), 'user_id' => $twitoaster_options['user_id'], 'in_urls_only' => true, 'in_titles_only' => true, 'show_replies' => true));

			// Twitoaster API Error Handling
			if ($twitoaster_api_result['error']) {
				if ($twitoaster_api_result['error']['user_issue']) {
					$twitoaster_options = twitoaster_options($twitoaster_options, true);
					update_option('twitoaster_options', $twitoaster_options);
				}
				else {
					$twitoaster_meta['expire'] = (time() + $twitoaster_options['api_timing']['short']);
					twitoaster_post_replies_update_meta('_twitoaster_post_replies', $post->ID, $twitoaster_meta);
				}
			}

			// Twitoaster API Data Processing
			else {
				if (get_post_time('U', $post) > (time() - 86400)) { $expire = $twitoaster_options['api_timing']['short']; }
				else if (get_post_time('U', $post) > (time() - 259200)) { $expire = $twitoaster_options['api_timing']['normal']; }
				else if (get_post_time('U', $post) > (time() - 1296000)) { $expire = $twitoaster_options['api_timing']['long']; }
				else { $expire = $twitoaster_options['api_timing']['huge']; }

				$twitoaster_meta_new = array('expire' => (time() + $expire), 'content' => array());
				foreach ($twitoaster_api_result['data'] AS $conversation) {
					if ($conversation->thread->created_at->unix_timestamp > get_post_time('U', $post)) {
						// Init
						$comment_parent_default = 0;

						// Threads
						if ($twitoaster_options['post_replies']['show_threads'] == 'yes') {
							// Thread doesn't exist
							if (!(array_key_exists($conversation->thread->id, $twitoaster_meta['content']))) {
								if ($twitoaster_meta_comment = twitoaster_post_replies_comment_insert($post->ID, 0, $conversation->thread)) {
									$twitoaster_meta_new['content'][$conversation->thread->id] = $twitoaster_meta_comment;
									$comment_parent_default = $twitoaster_meta_comment['comment_id'];
								}
								else { break; }
							}
							// Thread exists
							else {
								$twitoaster_meta_new['content'][$conversation->thread->id] = $twitoaster_meta['content'][$conversation->thread->id];
								$comment_parent_default = $twitoaster_meta['content'][$conversation->thread->id]['comment_id'];
							}
						}

						// Replies
						if (isset($conversation->replies)) {
							foreach($conversation->replies AS $reply) {
								// Reply doesn't exist
								if (!(array_key_exists($reply->id, $twitoaster_meta['content']))) {
									if (array_key_exists($reply->in_reply_to_status_id, $twitoaster_meta_new['content'])) { $comment_parent = $twitoaster_meta_new['content'][$reply->in_reply_to_status_id]['comment_id']; }
									else if (array_key_exists($reply->in_reply_to_status_id, $twitoaster_meta['content'])) { $comment_parent = $twitoaster_meta['content'][$reply->in_reply_to_status_id]['comment_id']; }
									else { $comment_parent = $comment_parent_default; }
									if ($twitoaster_meta_comment = twitoaster_post_replies_comment_insert($post->ID, $comment_parent, $reply)) {
										$twitoaster_meta_new['content'][$reply->id] = $twitoaster_meta_comment;
									}
									else { break; }
								}
								// Reply exists
								else {
									$twitoaster_meta_new['content'][$reply->id] = $twitoaster_meta['content'][$reply->id];
								}
							}
						}
					}
					else { break; }
				}

				// Update Twitoaster Meta
				$twitoaster_meta = $twitoaster_meta_new;
				twitoaster_post_replies_update_meta('_twitoaster_post_replies', $post->ID, $twitoaster_meta);
			}
		}
	}

	function twitoaster_post_replies_auto_thread()  {
		global $twitoaster_options, $twitoaster_meta_thread, $post;

		// Needs Auto Threading
		if (($post->post_status == 'publish') AND (get_post_time('U', $post) > $twitoaster_options['install_time']) AND (get_post_time('U', $post) > (time() - 86400)) AND ((empty($twitoaster_meta_thread['content'])) OR ($twitoaster_meta_thread['content'] == 'processing')) AND ($twitoaster_meta_thread['expire'] < time())) {
			//Meta Init & Lock
			$twitoaster_meta_thread = array('expire' => (time() + $twitoaster_options['api_timing']['short']), 'content' => 'processing');
			twitoaster_post_replies_update_meta('_twitoaster_post_auto_thread', $post->ID, $twitoaster_meta_thread);

			// Status preparation...
			$status = trim(preg_replace('/\s{2,}/', ' ', $post->post_title));
			if (!(seems_utf8($status))) { $status = utf8_encode($status); }
			if (mb_strlen($status) > 109) {
		    	$status = mb_substr($status, 0, 109);
			    $space = mb_strrpos($status, " ");
			    $status = mb_substr($status, 0, $space);
			}
			$status .= ' ' . get_permalink($post->ID);

			// Twitoaster API Request
			$twitoaster_api_result = twitoaster_api_request('POST', 'user/update', array('api_key' => $twitoaster_options['api_key'], 'extended' => false, 'status' => $status));

			// Twitoaster API Error Handling
			if ($twitoaster_api_result['error']) {
				$twitoaster_meta_thread['content'] = array();
				if ($twitoaster_api_result['error']['user_issue']) {
					$twitoaster_options = twitoaster_options($twitoaster_options, true);
					update_option('twitoaster_options', $twitoaster_options);
				}
			}

			// Twitoaster API Data Processing
			else {
				$twitoaster_meta_thread['content'] = array(
					'url' => $twitoaster_api_result['data']->thread->url,
					'id' => $twitoaster_api_result['data']->thread->id,
					'content' => $twitoaster_api_result['data']->thread->content,
					'user' => $twitoaster_api_result['data']->thread->user->id
				);
			}

			// Meta Update
			twitoaster_post_replies_update_meta('_twitoaster_post_auto_thread', $post->ID, $twitoaster_meta_thread);
		}
	}

	function twitoaster_post_replies_comment_insert($post_ID, $comment_parent, $twitoaster_data) {
		global $twitoaster_options;
		$data = array(
			'comment_post_ID' => $post_ID,
			'comment_author' => $twitoaster_data->user->screen_name,
			'comment_author_url' => ($twitoaster_data->user->url == false) ? '' : $twitoaster_data->user->url,
			'comment_author_IP' => 'Twitoaster Plugin',
			'comment_date' => date("Y-m-d H:i:s", $twitoaster_data->created_at->unix_timestamp),
			'comment_date_gmt' => gmdate("Y-m-d H:i:s", $twitoaster_data->created_at->unix_timestamp),
			'comment_content' => $twitoaster_data->content,
			'comment_approved' => ($twitoaster_options['post_replies']['moderation'] == 'yes') ? 0 : 1,
			'comment_agent' => 'Twitoaster||' . $twitoaster_data->id,
			'comment_type' => 'comment',
			'comment_parent' => $comment_parent
		);
		if (($comment_id = wp_insert_comment($data)) AND (is_numeric($comment_id)) AND ($comment_id > 0)) { return array('comment_id' => $comment_id, 'avatar' => $twitoaster_data->user->profile_image_url, 'url' => $twitoaster_data->url); }
		else { return false; }
	}

	function twitoaster_post_replies_get_meta($meta_key, $post_ID) {
		$meta = get_post_meta($post_ID, $meta_key, true);
		if (($meta != "") AND (is_array($meta))) { return $meta; }
		else if (($meta != "") AND (is_serialized($meta))) { return unserialize($meta); }
		else { return array('expire' => 1, 'content' => array()); }
	}

	function twitoaster_post_replies_update_meta($meta_key, $post_ID, $meta) {
		if (get_post_meta($post_ID, $meta_key, true) != "") { update_post_meta($post_ID, $meta_key, serialize($meta)); }
		else { add_post_meta($post_ID, $meta_key, serialize($meta), true); }
	}

	function twitoaster_post_replies_comment_meta($comment) {
		global $twitoaster_meta;
		$twitoaster_meta_comment_id = str_replace('Twitoaster||', '', $comment->comment_agent);
		if ((is_numeric($twitoaster_meta_comment_id)) AND (isset($twitoaster_meta['content'][$twitoaster_meta_comment_id]))) { return array('avatar' => $twitoaster_meta['content'][$twitoaster_meta_comment_id]['avatar'], 'url' => $twitoaster_meta['content'][$twitoaster_meta_comment_id]['url']); }
		else { return false; }
	}

	function twitoaster_post_replies_comment_avatar($avatar, $comment = false, $size = '32', $default = '', $alt = false) {
		if ($twitoaster_meta_comment = twitoaster_post_replies_comment_meta($comment)) { return '<img alt="' . $comment->comment_author . '" src="' . $twitoaster_meta_comment['avatar'] . '" class="avatar avatar-' . $size . ' photo" height="' . $size . '" width="' . $size . '" />'; }
		else { return $avatar; }
	}

	function twitoaster_post_replies_comment_content($text) {
		global $comment;
		if ($twitoaster_meta_comment = twitoaster_post_replies_comment_meta($comment)) { return $text . ' <i>(' . __('from') . ' <a href="' . htmlentities($twitoaster_meta_comment['url']) . '" title="' . htmlentities($comment->comment_content) . '">Twitoaster</a>)</i>'; }
		else { return $text; }
	}

	function twitoaster_post_replies_reset() {
		$allposts = get_posts('numberposts=0&post_type=post&post_status=');
		foreach( $allposts as $postinfo) {
			$twitoaster_meta = twitoaster_post_replies_get_meta('_twitoaster_post_replies', $postinfo->ID);
			foreach ($twitoaster_meta['content'] AS $twitoaster_meta_comment_id => $twitoaster_meta_comment) {
				if (is_numeric($twitoaster_meta_comment_id)) { wp_delete_comment($twitoaster_meta_comment['comment_id']); }
			}
			delete_post_meta($postinfo->ID, '_twitoaster_post_replies');
		}
	}

	function twitoaster_post_replies() {
		global $twitoaster_options, $twitoaster_meta, $twitoaster_meta_thread, $post;
		if (is_single()) {
			// Init
			$twitoaster_meta = twitoaster_post_replies_get_meta('_twitoaster_post_replies', $post->ID);
			$twitoaster_meta_thread = twitoaster_post_replies_get_meta('_twitoaster_post_auto_thread', $post->ID);

			// Filters
			add_filter('comment_text', 'twitoaster_post_replies_comment_content', 29);
			add_filter('get_avatar', 'twitoaster_post_replies_comment_avatar', 10, 5);

			// Post Replies
			if (($twitoaster_options['api_key'] != '') AND ($twitoaster_options['post_replies']['auto_threads'] == 'yes')) {
				twitoaster_post_replies_auto_thread();
			}

			// Auto Threading
			if (($twitoaster_options['api_key'] != '') AND ($twitoaster_options['post_replies']['twitter_comments'] == 'yes')) {
				if ($twitoaster_meta_thread['content'] != 'processing') { twitoaster_post_replies_twitter_comments(); }
			}
		}
	}

	add_action('loop_start', 'twitoaster_post_replies');

?>
